/********************************************************************************
*	NOTICE:														*
*																*
*	This code is believed by the author to be bug free.  You are free to use	*
*	and modify this code with the understanding that any use, either direct	*
*	or derivative, must contain acknowledgement of its author and source.		*
*	The author makes no warranty of any kind, expressed or implied, of		*
*	merchantability or fitness for a particular purpose.  The author shall	*
*	not be held liable for any incidental or consequential damages in		*
*	connection with or arising out of the furnishing, performance, or use of	*
*	this software.  This software is not authorized for use in life support	*
*	devices or systems.												*
*																*
********************************************************************************/

// AIPP software developed by Gianluca Di Pasqua, John Oh, and Sean Hanley
// in association with the DSP Lab at the University of Toronto, 2000.

import java.awt.*;
import java.awt.image.*;
import java.io.*;

// Super-class for noise functions
public abstract class noiseFilter extends EffectFilter
{
	// Global variables
	int SIZE = 1000;
	int Mid;
	
	// Returns a random value in a probability array	
	public void calc_array(double[] prob_in)
	{
		int Low = 0;
		int High = SIZE-1;
		double Rand = Math.random()*(SIZE-1) + 1;
		
		// Finds the value
		while (Low < High)
		{
			Mid = (Low + High)/2;
			if ((prob_in[Mid]* SIZE) < Rand)
			{
				Low = Mid +1;
			}
			else if ((prob_in[Mid] * SIZE) > Rand)
			{
				High = Mid -1;
			}
			else
			{
				Low = High = Mid;
			}
		}		
	}
}
